datablock TSShapeConstructor(MadmanPLDTS)
{
	baseShape = "./madmanPL.dts";
	sequence0 = "./default.dsq";
	sequence1 = "./mmFists.dsq";

};

datablock PlayerData(MadmanPLArmor : PlayerStandardArmor)
{
	shapeFile = "./madmanPL.dts";
	uniformCompatible = true;
	canJet = true;
	uiName = "Madman Player";
	
	//boundingBox = "7 7 13";
	//crouchBoundingBox = "8 13 5";
	
	isMadmanPL = true;
};

function Player::configureMadmanPL(%obj)
{
	// explanation for the next 40 or so lines: i imported jack noyer's melee playertype and just glued space marine body parts onto their corresponding limbs because i'm a hack with no animation skills
	%obj.hideNode("ALL");
	
	%obj.unHideNode("madhead");
	%obj.unHideNode("chest");
	%obj.unHideNode("pants");
	%obj.unHideNode("belt");
	%obj.unHideNode("buckle");
	%obj.unHideNode("rarm");
	%obj.unHideNode("larm");
	%obj.unHideNode("lshoe");
	%obj.unHideNode("lshoepad");
	%obj.unHideNode("lshoesole");
	%obj.unHideNode("rshoe");
	%obj.unHideNode("rshoepad");
	%obj.unHideNode("rshoesole");
	%obj.unHideNode("lhand");
	%obj.unHideNode("rhand");
}

package MadmanPLPlayer
{
	function Armor::onNewDataBlock(%this, %obj)
	{
		Parent::onNewDataBlock(%this, %obj);
		
		if(%this.isMadmanPL)
			%obj.schedule(50, applyBodyColors);
	}
	
	function GameConnection::applyBodyColors(%client) 
	{
		Parent::applyBodyColors(%client);
		
		if(isObject(%obj = %client.player))
		{
			if(%obj.getDatablock().isMadmanPL)
			{
				%obj.configureMadmanPL();
				
				%obj.setNodeColor("chest", %client.chestColor);
				
				%obj.setNodeColor("madhead", %client.headColor);
				
				%obj.setNodeColor("lhand", %client.LHandColor);
				%obj.setNodeColor("rhand", %client.RHandColor);
				
				%obj.setNodeColor("rarm", %client.LArmColor);
				%obj.setNodeColor("larm", %client.RArmColor);
				
				%obj.setNodeColor("belt", %client.PackColor);
				
				%obj.setNodeColor("Buckle", %client.hatColor);
				
				%obj.setNodeColor("rshoesole", getWords(%client.accentColor, 0, 2) SPC 1.0);
				%obj.setNodeColor("lshoesole", getWords(%client.accentColor, 0, 2) SPC 1.0);
				
				
				%obj.setNodeColor("pants", %client.hipColor);
				
				%obj.setNodeColor("rshoe", %client.RLegColor);
				%obj.setNodeColor("lshoe", %client.LLegColor);
				
				%obj.setNodeColor("rshoepad", %client.secondpackColor);
				%obj.setNodeColor("lshoepad", %client.secondpackColor);
			}
		}
	}
	
	function GameConnection::applyBodyParts(%client) 
	{
		Parent::applyBodyParts(%client);
		
		if(isObject(%obj = %client.player))
			if(%obj.getDatablock().isMadmanPL)
				%obj.configureMadmanPL();
	}
	
	function serverCmdUpdateBodyParts(%client, %hat, %accent, %pack, %secondPack, %chest, %hip, %LLeg, %RLeg, %LArm, %RArm, %LHand, %RHand)
	{
		if(isObject(%obj = %client.player))
			if((%obj.getDatablock()).isMadmanPL)
				return;
		
		Parent::serverCmdUpdateBodyParts(%client, %hat, %accent, %pack, %secondPack, %chest, %hip, %LLeg, %RLeg, %LArm, %RArm, %LHand, %RHand);
	}
	
};
ActivatePackage(MadmanPLPlayer);